## pstack 1.2

=== Makefile ===
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

VERSION = $(shell awk '/Version:/ { print $$2 }' pstack.spec)
CVSTAG = r$(subst .,-,$(VERSION))

CFLAGS = -Wall -DVERSION=\"$(VERSION)\" $(RPM_OPT_FLAGS)

ifeq ($(RPM_OPT_FLAGS),)
CFLAGS += -g
LDFLAGS += -g
endif

pstack : pstack.c
	$(CC) $(CFLAGS) -o pstack pstack.c

clean:
	rm pstack

install : pstack
	mkdir -p $(BINDIR)
	install -m 755 pstack $(BINDIR)
	mkdir -p $(MANDIR)/man1
	install -m 644 man1/pstack.1 $(MANDIR)/man1

cvstag:
	cvs tag -F $(CVSTAG) .

archive: cvstag
	@rm -rf /tmp/pstack-$(VERSION) /tmp/pstack
	@cd /tmp; cvs export -r$(CVSTAG) pstack; mv pstack pstack-$(VERSION)
	@cd /tmp; tar czSpf pstack-$(VERSION).tar.gz pstack-$(VERSION)
	@rm -rf /tmp/pstack-$(VERSION)
	@cp /tmp/pstack-$(VERSION).tar.gz .
	@echo " "
	@echo "The final archive is ./pstack-$(VERSION).tar.gz."

=== debian/changelog ===
pstack (1.2-3) unstable; urgency=low

  * Fix incorrect error checking. (Closes: #355660)
  * Don't segfault if no _DYNAMIC symbol found. (Closes: #350345)
  * Use strerror on syscall failure. (Closes: #355620)
  * debian/watch
    + Comment out watch file as upstream archives are no longer
      availables. (Closes: #450008)
  * debian/control
    + Bump Standard-Version from 3.8.4 to 3.9.2 (no changes needed).
  * debian/copyright
    + Update copyright notices
    + Convert to DEP5 candidate format.
  * debian/compat
    + Bump debhelper compatibility from 7 to 8 (no changes needed).
  * debian/rules
    + Use a dh based debian/rules file
  * debian/format
    + Switch to dpkg-source 3.0 (quilt) format.

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 18 Oct 2010 22:30:04 +0200

pstack (1.2-2) unstable; urgency=low

  * New maintainer. (Closes: #568574)
  * Fix "fails to open object file" error. (Closes: #360922)
  * debian/control
    - Remove reference to upstream repository from package description
    - Bump Standard-Version from 3.6.1 to 3.8.4 (no changes needed).
    - Set Vcs-Browser and Vcs-Git fields.
  * debian/compat
    - Bump debhelper compatibility from 4 to 7 (no changes needed).

 -- Thomas Preud'homme <robotux@celest.fr>  Tue, 10 Aug 2010 01:05:59 +0200

pstack (1.2-1) unstable; urgency=low

  * Initial Release. (Closes: #149048)
  * Added better handling of command line parameters.

 -- Baruch Even <baruch@debian.org>  Fri,  8 Oct 2004 17:13:40 +0100

=== debian/control ===
Source: pstack
Section: devel
Priority: optional
Maintainer: Thomas Preud'homme <robotux@celest.fr>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.9.2
Vcs-Browser: http://git.debian.org/?p=collab-maint/pstack.git;a=summary
Vcs-Git: git://git.debian.org/collab-maint/pstack.git

Package: pstack
Architecture: i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Display stack trace of a running process
 pstack dumps a stack trace for a process, given the pid of that process.  If
 the process named is part of a thread group, then all the threads in the group
 are traced.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export BINDIR = $$(DESTDIR)/usr/bin
export MANDIR = $$(DESTDIR)/usr/share/man

clean:
	rm -f build
	dh clean

build:
	dh build
	touch build

%:
	dh $@

=== debian/watch ===
version=3

# http://download.fedora.redhat.com/pub/fedora/linux/core/development/SRPMS/ pstack-([\d.]+)-[\d.]+\.src.rpm	debian	uupdate
# upstream archive is no longer available neither is the project website

## pstack 1.3.1

=== Makefile ===
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

VERSION = $(shell awk 'END { print $$1 }' VERSION)
CFLAGS ?= -Wall -Wextra -g -O2
CFLAGS += -DVERSION=\"$(VERSION)\"

# Note: assignments are ignored for variable overriden on command line VAR=value
# so DESTDIR is ignored for overriden variables
PREFIX ?= /usr
BINDIR ?= $(PREFIX)/bin
BINDIR := $(DESTDIR)$(BINDIR)
MANDIR ?= $(PREFIX)/share/man
MANDIR := $(DESTDIR)$(MANDIR)


pstack : pstack.c
	$(CC) $(CFLAGS) -o pstack pstack.c

clean:
	rm -f pstack

install : pstack
	mkdir -p "$(BINDIR)"
	install -m 755 pstack "$(BINDIR)"
	mkdir -p "$(MANDIR)/man1"
	install -m 644 man1/pstack.1 "$(MANDIR)/man1"

gittag:
	git tag -s pstack-$(VERSION)

archive: gittag
	@rm -rf /tmp/pstack-$(VERSION).tar.gz
	@git archive -o /tmp/pstack-$(VERSION).tar --prefix=pstack-$(VERSION)/ pstack-$(VERSION)
	@cd /tmp; gzip -9 pstack-$(VERSION).tar
	@cp /tmp/pstack-$(VERSION).tar.gz .
	@echo ""
	@echo "The final archive is ./pstack-$(VERSION).tar.gz."

=== debian/changelog ===
pstack (1.3.1-1) unstable; urgency=low

  * New upstream release
    + Drop all patches.
    + Add support for armel architecture.
  * debian/copyright:
    + Add missing hyphen in license statement: "GPL2+" -> "GPL-2+".
    + Give GPL-2+ its own License paragraph.
  * debian/control:
    + Reflect the new support of armel architecture.
  * debian/rules:
    + Remove no longer needed BINDIR and MANDIR variables.

 -- Thomas Preud'homme <robotux@celest.fr>  Mon, 03 Oct 2011 23:10:27 +0200

pstack (1.2-6) unstable; urgency=low

  * Fix compilation on i386: definition of __ASSEMPLY not needed.

 -- Thomas Preud'homme <robotux@celest.fr>  Sun, 11 Sep 2011 15:38:35 +0200

pstack (1.2-5) unstable; urgency=low

  * Add support for amd64. (LP: #532000)
  * Write pid in capital letter in long description, since it is an acronym.

 -- Thomas Preud'homme <robotux@celest.fr>  Sat, 10 Sep 2011 23:55:29 +0200

pstack (1.2-4) unstable; urgency=low

  * debian/rules:
    + Use dpkg-buildflags to set build flags (CPPFLAGS, CFLAGS and LDFLAGS).
  * debian/copyright: 
    + Document global license and copyright.
    + Set email and website of new upstream. (Closes: #608547)
  * debian/watch:
    + Set new URI to upstream resources.
  * debian/control:
    + Set DMUA flag.
    + Add a Homepage field.

 -- Thomas Preud'homme <robotux@celest.fr>  Fri, 19 Aug 2011 14:19:31 +0200

=== debian/control ===
Source: pstack
Section: devel
Priority: optional
Maintainer: Thomas Preud'homme <robotux@celest.fr>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.9.2
DM-Upload-Allowed: yes
Homepage: http://code.lm7.fr/p/pstack
Vcs-Browser: http://git.debian.org/?p=collab-maint/pstack.git;a=summary
Vcs-Git: git://git.debian.org/collab-maint/pstack.git

Package: pstack
Architecture: i386 amd64 armel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Display stack trace of a running process
 pstack dumps a stack trace for a process, given the PID of that process.  If
 the process named is part of a thread group, then all the threads in the group
 are traced.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

clean:
	rm -f build
	dh clean

build:
	dh build
	touch build

%:
	dh $@

=== debian/watch ===
version=3

http://code.lm7.fr/media/upload/pstack/files/ pstack_([\d.]+)\.tar.gz debian uupdate

## pstack 2.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
set(PSTACK_SOVERSION 2.14)
set(PSTACK_VERSION 2.14)
project(pstack LANGUAGES C CXX VERSION "${PSTACK_VERSION}" )

include (GNUInstallDirs)
enable_testing()
add_subdirectory(tests)

option(PYTHON3 "Compile with python 3 support" OFF)
option(PYTHON2 "Compile with python 2 support" ON)
option(DEBUGINFOD "Compile with debuginfod support" ON)

math(EXPR PLATFORM_BITS "${CMAKE_SIZEOF_VOID_P} * 8")
set(PSTACK_BIN "pstack" CACHE STRING "Name of the 'pstack' binary")

# Generate position independent code, even for static libs - that way we can
# link them to shared libs.
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}/" CACHE STRING "Rpath to install for binaries or the empty string")
set(LIBTYPE "SHARED" CACHE STRING "Build libraries as STATIC or SHARED")
option(TIDY "Run clang-tidy on the source" False)

find_library(LTHREADDB NAMES thread_db PATHS (/usr/lib /usr/local/lib))
find_package(LibLZMA)
find_package(ZLIB)

if (PYTHON2)
   find_package(Python2 COMPONENTS Development)
endif()
if (PYTHON3)
   find_package(Python3 COMPONENTS Development)
endif()

find_package(Git)
if (GIT_FOUND AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
   execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
      OUTPUT_VARIABLE GIT_TAG
      OUTPUT_STRIP_TRAILING_WHITESPACE
      )
   message(STATUS "Version from git tag: ${GIT_TAG}")
else()
   set(GIT_TAG "unknown")
   message(STATUS "git version information unavailable - defaulting to 'unknown'")
endif()

set(VERSION_TAG ${GIT_TAG} CACHE STRING "Version tag (defaults to git commit)")
message(STATUS "Version: ${VERSION_TAG}")

add_definitions(-DVERSION=${VERSION_TAG})

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_EXTENSIONS ON)

add_definitions("-Wall -Wextra -D_FILE_OFFSET_BITS=64 -D_LARGEFILE_SOURCE")
# Adding frame pointers makes things easy to run performance measurements with,
# and doesn't cost much itself.
add_definitions("-fno-omit-frame-pointer")
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
# Make sure to use the local libpstack headers rather than what's installed.
include_directories(${CMAKE_SOURCE_DIR})

if (LIBLZMA_FOUND)
   set(lzmasrc lzma.cc)
   add_definitions("-DWITH_LZMA")
   include_directories(${LIBLZMA_INCLUDES})
endif()

if (ZLIB_FOUND)
   set(inflatesrc inflate.cc)
   add_definitions("-DWITH_ZLIB")
   include_directories(${ZLIB_INCLUDES})
endif()

if (Python3_Development_FOUND OR Python2_Development_FOUND)
   set(pysrc python.cc)
endif()

if (PYTHON3 AND Python3_Development_FOUND)
   set(pyinc "-I${Python3_INCLUDE_DIRS}")
   message(STATUS  "Python3_INCLUDE_DIRS are ${pyinc}")
   add_definitions("-DWITH_PYTHON3")
   set(pysrc ${pysrc} python3.cc pythonc.c)
   set_source_files_properties(python3.cc PROPERTIES COMPILE_FLAGS ${pyinc})
   set_source_files_properties(pythonc.c PROPERTIES COMPILE_FLAGS ${pyinc})
   set_source_files_properties(canal.cc PROPERTIES COMPILE_FLAGS ${pyinc})
endif()

if (Python2_Development_FOUND)
   set(pysrc ${pysrc} python2.cc)
   add_definitions("-DWITH_PYTHON2")
   set_source_files_properties(python2.cc PROPERTIES COMPILE_FLAGS -I${Python2_INCLUDE_DIRS})
endif()

add_definitions("-g3")

add_library(dwelf ${LIBTYPE}
         dwarf_die.cc
         dwarf_frame.cc
         dwarf_info.cc
         dwarf_lines.cc
         dwarf_macros.cc
         dwarf_pubnames.cc
         dwarf_reader.cc
         dwarf_unit.cc
         dump.cc
         context.cc
         elf.cc
         flags.cc
         reader.cc
         ${inflatesrc}
         ${lzmasrc}
         )

add_library(procman ${LIBTYPE} dead.cc self.cc live.cc process.cc proc_service.cc
    dwarfproc.cc procdump.cc ${stubsrc} ${pysrc})

add_executable(canal canal.cc)

add_executable(${PSTACK_BIN} pstack.cc)

target_link_libraries(procman ${LTHREADDB} dwelf dl)
target_link_libraries(${PSTACK_BIN} dwelf procman)
target_link_libraries(canal dwelf procman)

set_target_properties(dwelf PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION "${PSTACK_SOVERSION}" )
set_target_properties(procman PROPERTIES VERSION ${PROJECT_VERSION} SOVERSION "${PSTACK_SOVERSION}" )

if (ZLIB_FOUND)
   target_link_libraries(dwelf ${ZLIB_LIBRARIES})
else()
   message(WARNING "no ZLIB support found")
endif()

if (LIBLZMA_FOUND)
   target_link_libraries(dwelf ${LIBLZMA_LIBRARIES})
else()
   message(WARNING "no LZMA support found")
endif()

if ((NOT (Python3_Development_FOUND)) AND PYTHON3)
   message(WARNING "no python3 support found")
endif()

if (NOT (Python2_Development_FOUND) AND PYTHON2)
   message(WARNING "no python2 support found")
endif()

if (DEBUGINFOD)
find_path (
   DEBUGINFOD_INCLUDE_DIR NAMES elfutils/debuginfod.h
   HINTS /usr/include/ ${CMAKE_INSTALL_FULL_INCLUDEDIR} )
find_library ( DEBUGINFOD_LIB NAMES debuginfod )

if(DEBUGINFOD_INCLUDE_DIR AND DEBUGINFOD_LIB)
   message(STATUS "found debuginfod header at ${DEBUGINFOD_INCLUDE_DIR}, lib at ${DEBUGINFOD_LIB}")
   target_link_libraries(dwelf ${DEBUGINFOD_LIB})
   add_definitions(-DDEBUGINFOD)
else()
   message(WARNING "no debuginod support found")
endif()
endif()

# bonus: heap debugger
add_library(hdbg SHARED heap.c)
add_executable(hdmp hdmp.cc)
add_executable(stackusers stackusers.cc)
target_link_libraries(hdmp dwelf procman)
target_link_libraries(hdbg dl)
target_link_libraries(stackusers dwelf procman)

install(TARGETS ${PSTACK_BIN} canal)
install(TARGETS hdmp)
install(TARGETS dwelf procman hdbg)
install(FILES ${CMAKE_SOURCE_DIR}/pstack.1 DESTINATION share/man/man1 RENAME ${PSTACK_BIN}.1 )
install(DIRECTORY libpstack DESTINATION include)
install(CODE "execute_process (COMMAND setcap cap_sys_ptrace+ep ${DESTDIR}${CMAKE_INSTALL_PREFIX}/bin/${PSTACK_BIN} RESULT_VARIABLE ret)
if (NOT ret EQUAL \"0\")
   message(\"(setcap failed - you might need to use sudo to use pstack: \${ret})\")
endif()
")

add_test(NAME args COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_CURRENT_SOURCE_DIR}/tests/args-test.py)
add_test(NAME badfp COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_CURRENT_SOURCE_DIR}/tests/badfp-test.py)
add_test(NAME basic COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_SOURCE_DIR}/tests/basic-test.py)
add_test(NAME cpp COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_CURRENT_SOURCE_DIR}/tests/cpp-test.py)
add_test(NAME noreturn COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_CURRENT_SOURCE_DIR}/tests/noreturn-test.py)
add_test(NAME segv COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_SOURCE_DIR}/tests/segv-test.py)
add_test(NAME thread COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_CURRENT_SOURCE_DIR}/tests/thread-test.py)
add_test(NAME jsondump COMMAND env PSTACK_BIN=${PSTACK_BIN} ${CMAKE_CURRENT_SOURCE_DIR}/tests/dump-test.py)
add_test(NAME procself COMMAND tests/procself)
if (PYTHON3 AND Python3_Development_FOUND)
   add_test(NAME pydict COMMAND env PSTACK_BIN=${PSTACK_BIN}${CMAKE_CURRENT_SOURCE_DIR}/tests/pydict_test.py)
endif()

# for automake and rpmbuild
add_custom_target(check COMMAND make test)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)
project(pstack-tests C CXX)

# Force debug build for tests. Many of the tests are looking at debug info that
# we need
set(CMAKE_BUILD_TYPE Debug)

set(CMAKE_CXX_STANDARD 20)

add_definitions("-O0 -D_FORTIFY_SOURCE=0 -I${CMAKE_SOURCE_DIR}")

add_library(testhelper STATIC abort.c)

add_executable(thread thread.cc)
add_executable(badfp badfp.c)
add_executable(basic basic.c)
add_executable(basic-zlib basic.c)
add_executable(basic-zlib-gnu basic.c)
add_executable(segv segv.c)
add_executable(segvrt segvrt.c)
add_executable(inline inline.c)
add_executable(args args.cc)
add_executable(noreturn noreturn.c noreturn-ext.c)
add_executable(cpp cpp.cc)
add_executable(procself procself.cc)

target_link_libraries(thread pthread testhelper)
target_link_libraries(badfp testhelper)
target_link_libraries(basic testhelper)
target_link_libraries(segv testhelper)
target_link_libraries(segvrt testhelper)
target_link_libraries(noreturn testhelper)
target_link_libraries(cpp testhelper)
target_link_libraries(inline testhelper)
target_link_libraries(procself dwelf procman)
SET_TARGET_PROPERTIES(noreturn PROPERTIES COMPILE_FLAGS "-O2 -g")


add_custom_command(
   OUTPUT basic-no-unwind-gen
   COMMAND ${CMAKE_OBJCOPY} --strip-debug --remove-section .eh_frame basic basic-no-unwind
   VERBATIM )

add_custom_target(basic-no-unwind ALL DEPENDS basic basic-no-unwind-gen)

# Build the basic executable with some options to compress debug sections with
# zlib and zlib-gnu, and ensure we can decode them

target_link_options(basic-zlib PUBLIC -Wl,--compress-debug-sections=zlib)
target_link_options(basic-zlib-gnu PUBLIC -Wl,--compress-debug-sections=zlib-gnu)

=== debian/changelog ===
pstack (2.14-1) unstable; urgency=medium

  * Non-maintainer upload.
  * 

 -- lichenggang <lichenggang@deepin.org>  Thu, 07 Aug 2025 10:26:09 +0800

=== debian/control ===
Source: pstack
Section: devel
Priority: optional
Maintainer: lichenggang <lichenggang@deepin.org>
Build-Depends: debhelper (>= 8.0.0), cmake, 
Standards-Version: 3.9.2
Homepage: https://github.com/peadar/pstack.git
Vcs-Browser: https://github.com/peadar/pstack.git
Vcs-Git: https://github.com/peadar/pstack.git

Package: pstack
Architecture: amd64 arm64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Display stack trace of a running process
 pstack dumps a stack trace for a process, given the PID of that process.  If
 the process named is part of a thread group, then all the threads in the group
 are traced.

=== debian/rules ===
--- 
+++ 
@@ -17,3 +17,5 @@
 
 %:
 	dh $@
+
+override_dh_auto_test:
